{- |
NullIO:

Always reads empty string, writes are null routed,
always at EOF.
-}
module System.IO.Uniform.Null (
  NullIO(..)
  ) where

import System.IO.Uniform

import qualified Data.ByteString as BS

-- | Wrapper that does UniformIO that reads and writes on the memory.
data NullIO = NullIO
instance UniformIO NullIO where
  uRead _ _ = return BS.empty
  uPut _ _ = return ()
  uClose _ = return ()
  startTls _ = return
  isSecure _ = True
  isEOF _ = return True
